<template>
<div v-if="this.$store.getters.authenticatedUser">
    <b-container>
<b-modal ref="my-modal" hide-footer title="Confirmation message">
      <div class="d-block text-center">
        <h6>New region has been added!</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">
          <router-link :to="{name: 'Regions'}">
          <b-button class="mt-3" variant="success" block >Ok</b-button>
          </router-link>
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>
<b-modal ref="failure-modal" hide-footer title="Rejection message">
      <div class="d-block text-center">
        <h6>The region you wish to create already exists!</h6>
      </div>
      <div> <b-row>
        <b-col cols="4"></b-col>
        <b-col cols="4">          
          <b-button class="mt-3" variant="warning" block @click="hideModal" >Ok</b-button>          
        </b-col>
      <b-col cols="4"></b-col>
      </b-row>
      </div>
    </b-modal>
<br>
<br>
<b-row>
<b-col cols="3"></b-col>
<b-col cols="6">
  <b-card id="addCard" bg-variant="light">
       <b-row rows="2"  > <p style=" color: #22b574 ; font-size: 200%">
            Create New Region
            </p>
        </b-row>
        <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Country:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "country"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyCountryAlert" variant="warning">
                  You have to provide the name of the country!
                </b-alert>
      </b-form-group>
      </b-col>
      </b-row>
      <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Region:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "region"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyRegionAlert" variant="warning">
                  You have to provide the name of the region!
                </b-alert>
      </b-form-group>
      </b-col>
      </b-row>
      <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="City:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "city"
        ></b-form-input>
        <b-alert dismissible style="width: 100%" v-model="emptyCityAlert" variant="warning">
                  You have to provide the name of the city!
                </b-alert>
      </b-form-group>
      </b-col>
      </b-row>
      <b-row>
          <b-col>
            <b-form-group
        label-cols-sm="3"
        label="Zip Code:"
        label-align-sm="right"
        label-for="nested-name"
      >
        <b-form-input id="nested-name"
            v-model = "zipcode"
        ></b-form-input>
      </b-form-group>
      </b-col>
      </b-row>
<b-row>
<b-col>
</b-col>
<b-col>
<div  id="SaveButtonRow" @click="checkForm"  @mouseover="SavemouseOver"  @mouseleave="SavemouseOut">
 <img v-if="HoverSave"
 width="25%" src= "../assets/SaveButtonAtHover.png" >
  <img v-if="OutOfSave"
 width="25%" src= "../assets/SaveButton.png" >
 </div>
</b-col>
</b-row>
  </b-card>
  </b-col>
<b-col cols="3"></b-col>
</b-row>
    </b-container>
</div>
<div v-else>
  <NoAccess></NoAccess>
  </div>
</template>
<script>
import NoAccess from '../components/NoAccess.vue'
import {mapGetters} from 'vuex'

export default {
  computed: {
    ...mapGetters([
      'authenticatedUser'
    ])
  },
  data () {
    return {
      emptyCityAlert: false,
      emptyRegionAlert: false,
      emptyCountryAlert: false,
      country: '',
      region: '',
      city: '',
      zipcode: '',
      HoverSave: false,
      OutOfSave: true
    }
  },
  components: {NoAccess},
  beforeCreate () {
    console.log(this.$store.getters.authenticatedUser)
    if (this.$store.getters.authenticatedUser === false) {
      this.$router.push({name: 'home'})
    }

  },

  created () {
  },
  methods: {
    checkForm () {
      // check if all required fields are filled
        if (!this.country) {
          this.emptyCountryAlert = true
        }
        else if (!this.region) {
          this.emptyRegionAlert = true
        }
        else if (!this.city) {
          this.emptyCityAlert = true
        }
       else {
        this.CreateRegion()
       }
    },
    CreateRegion () {
      let DataToBeSent = []
      DataToBeSent = {
        country: this.country,
        region: this.region,
        zipcode: this.zipcode,
        city: this.city
      }
      this.$store.dispatch('createRegion', DataToBeSent).then(
        response => {
          console.log(response)
          if(response.status) {
            if (response.status = '201'){ this.$refs['my-modal'].show()}
            } 
          else if (response.response.status = '409')
         {this.$refs['failure-modal'].show()}
          }
      )
       // .catch(
        //  this.$refs['failure-modal'].show()
        //  )
        
    },
    hideModal () {
      this.$refs['failure-modal'].hide()
    },

    SavemouseOver () {
      this.HoverSave = true
      this.OutOfSave = false
    },
    SavemouseOut () {
      this.HoverSave = false
      this.OutOfSave = true
    }}
}
</script>

<style scoped>

#addCard {
  border : 0px
}
#SaveButtonRow {
  text-align : right;
   cursor: pointer;
}
</style>
